import 'dart:math';

import 'package:location/location.dart';
import 'package:nueli/nueli.dart';

class DeviceLocation {
  static List<LocationData> history = [];

  static Future initialize() async {
    Location _location = Location();
    if (await _location.requestPermission() == PermissionStatus.denied) return initialize();
    LocationData locationData = await _location.getLocation();
    history.add(locationData);
  }

  static Future<bool> refresh() async {
    Location _location = Location();
    if (await _location.requestPermission() == PermissionStatus.denied) return await refresh();
    if (slope(history.last.point, history.last.point) > 100) {
      LocationData locationData = await _location.getLocation();
      history.add(locationData);
      return true;
    }
    return false;
  }

  static LocationData get current => history.last;
}

extension LocationPoint on LocationData {
  Point get point => Point(latitude, longitude);
}
